addHook("PlayerThink", function(p)
	if not p.mo or not p.mo.valid then return end
	Blossom_Vines(p)
	Blossom_Tornado(p)
	Blossom_Misc(p)
end)

addHook("PostThinkFrame", function()
	for p in players.iterate do
		if not p.mo or not p.mo.valid then continue end
		Blossom_PostThink(p)
	end
end)

addHook("MobjMoveBlocked", function(mobj, thing, line)
	if mobj.user and mobj.user.mo.vinetarg and (mobj.user.mo.vinetarg[4] or mobj.user.mo.blossom_tornado) then return end -- If we're targetting an enemy
	if not line or not line.valid then return end

	--- can i like kill myself
	if (line.frontsector)
		if ((line.frontsector.ceilingheight == line.frontsector.floorheight) and (mobj.z > line.frontsector.ceilingheight))
		or (line.backsector and line.frontsector.floorheight > line.backsector.floorheight and mobj.z > line.frontsector.floorheight)
		or (line.backsector and line.frontsector.ceilingheight < line.backsector.ceilingheight and (mobj.z+mobj.height) > line.frontsector.ceilingheight)
			return
		end
	end

	if (line.backsector)
		if ((line.backsector.ceilingheight == line.backsector.floorheight) and (mobj.z > line.backsector.ceilingheight))
		or (line.frontsector and line.backsector.floorheight > line.frontsector.floorheight and mobj.z > line.backsector.floorheight)
		or (line.frontsector and line.backsector.ceilingheight < line.frontsector.ceilingheight and (mobj.z+mobj.height) > line.backsector.ceilingheight)
			return
		end
	end

	mobj.hitwall = line -- Hit the wall.
	mobj.flags = $|MF_NOCLIPHEIGHT
--	local x, y = P_ClosestPointOnLine(mobj.x, mobj.y, line)
--	P_TeleportMove(mobj, x, y, mobj.z)

	if mobj.user and mobj.user.mo and mobj.user.mo.valid and mobj.user.mo.targvine and mobj.user.mo.targvine[3] and not mobj.user.mo.blossom_set_targvine then
		S_StartSound(mobj, sfx_s3k4a)
		mobj.user.mo.targvine[3] = 30
		mobj.user.mo.drawangle = R_PointToAngle2(mobj.user.mo.x, mobj.user.mo.y, mobj.x, mobj.y)
		mobj.user.mo.blossom_set_targvine = true
	end
end, MT_VINETARG)

addHook("PlayerCanDamage", function(p, mo)
	if p.mo.blossom_fastfall and (mo.flags & MF_SHOOTABLE) then
		if p.mo.momz < 0 then p.mo.momz = -p.mo.momz/2 end
		p.mo.blossom_fastfall = nil
		p.mo.blossom_fallingz = nil
		p.mo.spritexscale = FRACUNIT
		p.mo.spriteyscale = FRACUNIT
		p.mo.player.pflags = $ & ~PF_SHIELDABILITY
		if (p.cmd.forwardmove > 30) then P_Thrust(p.mo, p.mo.angle, 15*FRACUNIT) end
		if not (mo.flags & MF_BOSS) then P_SetObjectMomZ(mo, -20*FRACUNIT, true) end
		return true
	end

	if hasShield(p, SH_ATTRACT) and p.mo.blossom_tornado then return true end
	if p.mo.state == S_PLAY_BLOSSOM_TORNADO then return true end
end)

addHook("ShouldDamage", function(t, i, s, d, dt)
	if not t or not t.valid then return end
	if not i or not i.valid then return end
	if (dt & DMG_DEATHMASK) then return end

	if t.player and t.skin == "blossom" then
		if t.targvine and t.targvine[4] and t.targvine[4] == i then return false end
		if t.blossom_invinc then return false end

		if (t.player.powers[pw_shield] & SH_FORCE) and t.blossom_tornado and t.blossom_tornado <= 65 then
			t.player.powers[pw_flashing] = 20
			S_StartSound(t, sfx_s3k7b)
			return false
		end

		if hasShield(t.player, SH_ATTRACT) and t.blossom_tornado then return false end
	end
end, MT_PLAYER)

addHook("MobjDamage", function(mo, inf, src, d, dt)
	if not mo.player then return end
	if mo.skin ~= "blossom" then return end

	mo.blossom_didsuper = nil
	mo.blossom_didsuper_horizontal = nil
	mo.blossom_autospringremove = nil
	mo.blossom_wallslide = nil
	mo.blossom_superjump = nil
	mo.blossom_notonwall = nil
	mo.player.notornado = nil
	mo.player.notornadogrounded = nil
	mo.blossom_cancelled = nil
	mo.blossom_slidetimer = nil
	mo.spin_stuff = nil
	mo.blossom_grounded = nil
	mo.blossom_tornado = nil

	if mo.targvine then
		if mo.targvine[1] and mo.targvine[1].valid then P_RemoveMobj(mo.targvine[1]) end
		mo.targvine = nil
	end

	mo.backup = nil
	mo.targvine = nil
	mo.blossom_didvine = nil
	mo.blossom_didtornado = nil

	if mo.blossom_fastfall then
		mo.blossom_fastfall = nil
		mo.spritexscale = FRACUNIT
		mo.spriteyscale = FRACUNIT
	end

	if mo.blossom_duckdance then
		mo.blossom_duckdance = nil
		P_RestoreMusic(mo.player)
	end

	mo.blossom_waittimer = nil
	mo.blossom_isidling = nil
	mo.blossom_dothings = nil
	if S_SoundPlaying(mo, sfx_uigoku) then
		S_StopSoundByID(mo, sfx_uigoku)
		S_ResumeMusic(mo.player)
	end

	mo.flags = $ & ~MF_NOGRAVITY
end, MT_PLAYER)

-- Make Blossom enter her tornado state upon physical damage.
addHook("MobjDamage", function(mo, inf)
	if not inf or not inf.valid then return end

	if inf.skin == "blossom" and inf.player and not P_IsObjectOnGround(inf) and inf.z > mo.z then
		inf.state = S_PLAY_BLOSSOM_TORNADO
		inf.blossom_didtornado = nil
		inf.blossom_didvine = nil
	end
end)

local mobjs = {MT_THOK, MT_DUSTLAYER}

for i = 1, #mobjs do
	addHook("MobjThinker", function(mo)
		if not mo or not mo.valid then return end

		if mo.leaf and mo.upwardz and mo.upwardz >= 60*FRACUNIT then
			mo.momx = ($/35)*34
			mo.momy = ($/35)*34
			mo.momz = max(-5*FRACUNIT, $-FRACUNIT)

			P_XYMovement(mo)
			P_ZMovement(mo)

			if mo and mo.valid then
				if mo.fuse then
					mo.fuse = $-1
					if mo.fuse <= 0 then P_RemoveMobj(mo) end
				end
			end

			return true
		end
	end, mobjs[i])
end

addHook("HurtMsg", function(mo, inf)
	if inf.blossom_tornado then
		print(inf.player.name.."'s tornado damaged "..mo.player.name..".")
		return true
	end
end, MT_PLAYER)

-- Spring
addHook("MobjCollide", Blossom_SpringHandler, MT_PLAYER)
addHook("MobjMoveCollide", Blossom_SpringHandler, MT_PLAYER)

-- Duck Dance
addHook("ShouldJingleContinue", function(p, musname)
	if musname ~= "heyya" then return end
	return (p and p.mo and p.mo.skin == "blossom" and p.mo.blossom_duckdance) or (p and p.mo and p.mo.skin == "flimp" and p.mo.flimp_duckdance)
end)