rawset(_G, "Blossom_Misc", function(p)
	if not p.mo or not p.mo.valid then return end

	-- lmao
	if p.playerstate ~= PST_DEAD then
		if p.mo.blossom_tanukianim then
			p.mo.color = p.skincolor
			p.mo.colorized = false
			p.mo.blossom_tanukianim = $-1

			p.mo.spritexscale = 2*FRACUNIT
			p.mo.spriteyscale = 2*FRACUNIT
			p.mo.spriteyoffset = 10*FRACUNIT

			if p.mo.blossom_tanukianim <= 0 then
				p.tanukisuit = not p.tanukisuit
				p.mo.spritexscale = FRACUNIT
				p.mo.spriteyscale = FRACUNIT
				p.mo.spriteyoffset = 0
				p.mo.sprite = SPR_PLAY
				p.mo.blossom_tanukianim = nil
			end
		elseif p.tanukisuit then
			p.drawangle = p.mo.angle

			if P_IsObjectOnGround(p.mo) then
				if not (leveltime%20) then P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_SPINDUST) end
				if p.speed > 0 and not S_SoundPlaying(p.mo, sfx_statu2) then S_StartSound(p.mo, sfx_statu2) end

				if not p.mo.blossom_slamsound then
					p.mo.blossom_slamsound = true

					local x, y, dust
					for i = 1, 16 do
						x = 48*cos(i*ANGLE_22h)
						y = 48*sin(i*ANGLE_22h)
						dust = P_SpawnMobjFromMobj(p.mo, x, y, 8*FRACUNIT, MT_SPINDUST)
						dust.scale = 2*FRACUNIT
					end

					if p == displayplayer then
						P_StartQuake(32*FRACUNIT, 10, {p.mo.x, p.mo.y, p.mo.z}, 512*FRACUNIT)
						S_StartSound(p.mo, sfx_tf2pan)
					end
				end
			else
				p.mo.blossom_slamsound = nil
			end
		end
	end

	-- Let's make the flimp persist between characters.
	if p.mo.blossom_flimp and p.mo.blossom_flimp.valid then
		local flimp = p.mo.blossom_flimp

		if flimp.golden or flimp.hyper then
			local spriteframe = max(0, min(2, (leveltime%6)/2))

			if flimp.hyper then
				flimp.color = (leveltime%60)
			else
				flimp.color = SKINCOLOR_SUPERGOLD1 + abs(((leveltime >> 1) % 9) - 4)
			end

			flimp.colorized = true

			local spark

			if not flimp.originalaura or not flimp.originalaura.valid then
				spark = P_SpawnMobjFromMobj(flimp, cos(R_PointToAngle(flimp.x, flimp.y)), sin(R_PointToAngle(flimp.x, flimp.y)), 0, MT_DUMMYOBJ)
				spark.sprite = SPR_SUPF
				spark.frame = FF_FULLBRIGHT|FF_TRANS80|spriteframe
				spark.blendmode = AST_ADD
				spark.color = flimp.color
				spark.colorized = true
				spark.fuse = 5

				flimp.originalaura = spark
			else
				P_MoveOrigin(flimp.originalaura, flimp.x + cos(R_PointToAngle(flimp.x, flimp.y)), flimp.y + sin(R_PointToAngle(flimp.x, flimp.y)), flimp.z)
				flimp.originalaura.frame = FF_FULLBRIGHT|FF_TRANS80|spriteframe
				flimp.originalaura.scale = flimp.scale
				flimp.originalaura.color = flimp.color
				flimp.originalaura.fuse = 5
			end

			if not flimp.superauras then flimp.superauras = {} end

			for i = 11, 13 do
				if not flimp.superauras[i] or not flimp.superauras[i].valid then
					spark = P_SpawnMobjFromMobj(flimp, cos(R_PointToAngle(flimp.x, flimp.y)), sin(R_PointToAngle(flimp.x, flimp.y)), 0, MT_DUMMYOBJ)
					spark.sprite = SPR_SUPF
					spark.frame = FF_FULLBRIGHT|FF_TRANS90|spriteframe
					spark.scale = (flimp.scale/10)*i
					spark.blendmode = AST_ADD
					spark.color = flimp.color
					spark.colorized = true
					spark.fuse = 5

					flimp.superauras[i] = spark
				else
					P_MoveOrigin(flimp.superauras[i], flimp.x + cos(R_PointToAngle(flimp.x, flimp.y)), flimp.y + sin(R_PointToAngle(flimp.x, flimp.y)), flimp.z)
					flimp.superauras[i].frame = FF_FULLBRIGHT|FF_TRANS90|spriteframe
					flimp.superauras[i].scale = (flimp.scale/10)*i
					flimp.superauras[i].color = flimp.color
					flimp.superauras[i].fuse = 5
				end
			end

			if not (leveltime%5) then
				spark = P_SpawnMobjFromMobj(flimp, P_RandomRange(-50, 50)*FRACUNIT, P_RandomRange(-50, 50)*FRACUNIT, P_RandomRange(-50, 50)*FRACUNIT, MT_BOXSPARKLE)
				spark.scale = 2*FRACUNIT
				spark.destscale = 1
				spark.color = flimp.color
				spark.colorized = true
				spark.fuse = 20
			end
		end

		if p.mo.blossom_returnflimp then
			p.blossom_keepflimp = nil

			local x = p.mo.x
			local y = p.mo.y
			local z = p.mo.z + FixedMul(p.mo.height/2, p.mo.scale)
			local dist = P_AproxDistance(P_AproxDistance(x - flimp.x, y - flimp.y), z - flimp.z)

			flimp.destscale = 1
			flimp.fuse = 20
			flimp.frame = 0
			if dist >= 12*p.mo.scale then
				flimp.momx = (x - flimp.x)/6
				flimp.momy = (y - flimp.y)/6
				flimp.momz = (z - flimp.z)/6
				flimp.angle = R_PointToAngle2(0, 0, flimp.momx, flimp.momy)
			else
				P_RemoveMobj(flimp)
			end
		else
			p.blossom_keepflimp = flimp.hyper and 3 or ((flimp.golden) and 2 or 1)

			local x = p.mo.x + FixedMul(50*cos(p.drawangle + ANGLE_225), p.mo.scale)
			local y = p.mo.y + FixedMul(50*sin(p.drawangle + ANGLE_225), p.mo.scale)
			local z = p.mo.z + 50*p.mo.scale

			if p.mo.blossom_isidling then
				x = p.mo.x
				y = p.mo.y
				z = p.mo.z + FixedMul(p.mo.height, p.mo.scale)
			end

			flimp.destscale = p.mo.scale
			flimp.fuse = 5
			flimp.frame = 0

			local dist = P_AproxDistance(P_AproxDistance(x - flimp.x, y - flimp.y), z - flimp.z)

			if dist >= 2056*p.mo.scale and not p.mo.blossom_duckdance then
				P_SetOrigin(flimp, x, y, z)
				flimp.scale = 1
			elseif dist >= 256*p.mo.scale and not p.mo.blossom_duckdance then
				p.mo.blossom_flimpspeed = $ and $+1 or 1

				if p.mo.blossom_flimpspeed >= 70 then
					flimp.momx = (x - flimp.x)/2
					flimp.momy = (y - flimp.y)/2
					flimp.momz = (z - flimp.z)/2
					flimp.angle = R_PointToAngle2(0, 0, flimp.momx, flimp.momy)
				else
					flimp.momx = (x - flimp.x)/6
					flimp.momy = (y - flimp.y)/6
					flimp.momz = (z - flimp.z)/6
					flimp.angle = R_PointToAngle2(0, 0, flimp.momx, flimp.momy)
				end
			elseif dist >= 64*p.mo.scale then
				if p.mo.blossom_flimpspeed and p.mo.blossom_flimpspeed > 0 then
					if p.speed < 5*FRACUNIT then p.mo.blossom_flimpspeed = $-1 end

					if not (leveltime%10) then
						local sweat = P_SpawnMobjFromMobj(flimp, P_RandomRange(-20, 20)*FRACUNIT, P_RandomRange(-20, 20)*FRACUNIT, P_RandomRange(10, 50)*FRACUNIT, MT_WATERDROP)
						sweat.fuse = 35
					end

					if p.mo.blossom_flimpspeed <= 0 then p.mo.blossom_flimpspeed = nil end

					flimp.momx = (x - flimp.x)/2
					flimp.momy = (y - flimp.y)/2
					flimp.momz = (z - flimp.z)/2
				else
					flimp.momx = (x - flimp.x)/6
					flimp.momy = (y - flimp.y)/6
					flimp.momz = (z - flimp.z)/6
				end

				flimp.angle = R_PointToAngle2(0, 0, flimp.momx, flimp.momy)
			else
				if p.mo.blossom_flimpspeed and p.mo.blossom_flimpspeed > 0 then
					p.mo.blossom_flimpspeed = $-1

					if not (leveltime%10) then
						local sweat = P_SpawnMobjFromMobj(flimp, P_RandomRange(-20, 20)*FRACUNIT, P_RandomRange(-20, 20)*FRACUNIT, P_RandomRange(10, 50)*FRACUNIT, MT_WATERDROP)
						sweat.fuse = 35
					end

					if p.mo.blossom_flimpspeed <= 0 then p.mo.blossom_flimpspeed = nil end
				end

				flimp.angle = p.mo.blossom_isidling and (p.drawangle + ANGLE_180) or p.drawangle
				flimp.momx = ($/10)*9
				flimp.momy = ($/10)*9
				flimp.momz = ($/10)*9
			end
		end
	elseif p.blossom_keepflimp then
		local x = p.mo.x + FixedMul(50*cos(p.drawangle + ANGLE_225), p.mo.scale)
		local y = p.mo.y + FixedMul(50*sin(p.drawangle + ANGLE_225), p.mo.scale)
		local z = p.mo.z + 50*p.mo.scale
		local flimp = P_SpawnMobj(x, y, z, MT_DUMMYOBJ)
		flimp.sprite = SPR_FLIM
		flimp.color = netgame and p.skincolor or SKINCOLOR_SHAMROCK
		flimp.golden = (p.blossom_keepflimp == 2)
		flimp.hyper = (p.blossom_keepflimp == 3)
		p.mo.blossom_flimp = flimp
	else
		p.mo.blossom_returnflimp = nil
	end

	-- ok if we're not blossom lets not do anymore
	if p.mo.skin ~= "blossom" then
		p.mo.blossom_didsuper = nil
		p.mo.blossom_didsuper_horizontal = nil
		p.mo.blossom_autospringremove = nil
		p.mo.blossom_wallslide = nil
		p.mo.blossom_superjump = nil
		p.mo.blossom_notonwall = nil
		p.mo.blossom_cancelled = nil
		p.mo.blossom_grounded = nil
		p.mo.blossom_tornado = nil
		p.mo.blossom_slidetimer = nil

		if p.mo.targvine then
			if p.mo.targvine[1] and p.mo.targvine[1].valid then P_RemoveMobj(p.mo.targvine[1]) end
			p.mo.targvine = nil
		end

		p.mo.blossom_didvine = nil
		p.mo.blossom_didtornado = nil

		if p.mo.blossom_fastfall then
			p.mo.blossom_fastfall = nil
			p.mo.spritexscale = FRACUNIT
			p.mo.spriteyscale = FRACUNIT
		end

		if p.mo.blossom_duckdance then
			p.mo.state = S_PLAY_STND
			if p.mo.momz > 0 then p.mo.state = S_PLAY_SPRING end
			if S_SoundPlaying(p.mo, sfx_uigoku) then S_StopSoundByID(p.mo, sfx_uigoku) end
			if p.mo.blossom_duckdance == 2 then S_ResumeMusic(p) end
			p.mo.blossom_duckdance = nil
			P_RestoreMusic(p)
		end

		p.mo.blossom_waittimer = nil
		p.mo.blossom_isidling = nil
		p.mo.blossom_dothings = nil
		if S_SoundPlaying(p.mo, sfx_uigoku) then
			S_StopSoundByID(p.mo, sfx_uigoku)
			S_ResumeMusic(p)
		end

		return
	end

	if p.mo.blossom_invinc then
		p.mo.blossom_invinc = $-1
		if p.mo.blossom_invinc <= 0 then p.mo.blossom_invinc = nil end
	end

	if p.playerstate == PST_DEAD or P_PlayerInPain(p) or p.powers[pw_carry] then
		p.mo.blossom_didsuper = nil
		p.mo.blossom_didsuper_horizontal = nil
		p.mo.blossom_autospringremove = nil
		p.mo.blossom_wallslide = nil
		p.mo.blossom_superjump = nil
		p.mo.blossom_notonwall = nil
		p.notornado = nil
		p.notornadogrounded = nil
		p.mo.blossom_cancelled = nil
		p.mo.spin_stuff = nil
		p.mo.blossom_grounded = nil
		p.mo.blossom_tornado = nil
		p.mo.blossom_slidetimer = nil

		if p.mo.targvine then
			if p.mo.targvine[1] and p.mo.targvine[1].valid then P_RemoveMobj(p.mo.targvine[1]) end
			p.mo.targvine = nil
		end

		p.mo.backup = nil
		p.mo.targvine = nil
		p.mo.blossom_didvine = nil
		p.mo.blossom_didtornado = nil

		if p.mo.blossom_fastfall then
			p.mo.blossom_fastfall = nil
			p.mo.spritexscale = FRACUNIT
			p.mo.spriteyscale = FRACUNIT
		end

		if p.mo.blossom_duckdance then
			p.mo.blossom_duckdance = nil
			P_RestoreMusic(p)
		end

		p.mo.blossom_waittimer = nil
		p.mo.blossom_isidling = nil
		p.mo.blossom_dothings = nil
		if S_SoundPlaying(p.mo, sfx_uigoku) then
			S_StopSoundByID(p.mo, sfx_uigoku)
			S_ResumeMusic(p)
		end

		p.mo.flags = $ & ~MF_NOGRAVITY
	end

	if (p.mo.state == S_PLAY_BLOSSOM_TORNADO) then p.drawangle = (leveltime*ANG20) end

	-- Grounded resets
	if P_IsObjectOnGround(p.mo) then
		p.notornadogrounded = nil
		p.mo.blossom_cancelled = nil
		p.mo.blossom_didtwirl = nil
		p.mo.blossom_twirltimer = nil
		p.mo.blossom_didvine = nil
		p.mo.blossom_didtornado = nil
	end

	-- Idle
	if p.mo.blossom_isidling then
		p.mo.blossom_dothings = $ and $+1 or 1
		if p.mo.blossom_dothings >= 35 then p.mo.blossom_dothings = 0 end

		if p.speed > 0 or p.mo.blossom_tornado or p.hugging or not P_IsObjectOnGround(p.mo) or p.tanukisuit or p.mo.blossom_tanukianim then
			p.mo.z = $+FRACUNIT
			p.mo.state = S_PLAY_WALK
			if p.mo.momz > 0 then p.mo.state = S_PLAY_SPRING end
			p.mo.blossom_waittimer = nil
			p.mo.blossom_isidling = nil
			p.mo.blossom_dothings = nil
			p.drawangle = p.mo.angle - ANGLE_180
		else
			p.mo.sprite2 = SPR2_MLEE
			p.mo.frame = (p.mo.blossom_isidling.frame or 0) + (p.mo.blossom_dothings >= 17 and 1 or 0)
		end
	elseif p.mo.blossom_waittimer then
		p.mo.state = S_PLAY_STND
		if p.speed > 0 or p.mo.blossom_tornado or p.hugging or not P_IsObjectOnGround(p.mo) or p.tanukisuit or p.mo.blossom_tanukianim then
			p.mo.z = $+FRACUNIT
			p.mo.blossom_waittimer = nil
			p.mo.blossom_isidling = nil
			p.mo.blossom_dothings = nil
		else
			p.mo.blossom_waittimer = $ and $+1 or 1

			if p.mo.blossom_waittimer <= 16 then
				p.mo.sprite2 = SPR2_TWIN
				p.mo.frame = min(3, max(0, (p.mo.blossom_waittimer/4)-1))
			else
				p.mo.blossom_waittimer = nil

				local chance = P_RandomRange(1, 100)

				local rarity = 3
				if chance <= 12 then rarity = ((chance <= 2) and 1 or 2) end

				local flowers = Blossom_FlowerTypes[rarity]
				p.mo.blossom_isidling = flowers[P_RandomRange(1, #flowers)]

				if p.mo.blossom_isidling then
					if p.mo.blossom_isidling.nothing then return end

					if p.mo.blossom_isidling.sound then
						S_StartSound(p.mo, p.mo.blossom_isidling.sound)
					else
						S_StartSound(p.mo, sfx_hoop3)
					end

					if rarity == 2 then S_StartSound(p.mo, sfx_ncitem) end
					if rarity == 1 then S_StartSound(p.mo, sfx_ideya) end
				end
			end
		end
	else
		if p.mo.state == S_PLAY_WAIT and not p.tanukisuit and not p.mo.blossom_tanukianim then p.mo.blossom_waittimer = 1 end
	end

	-- Duck Dance
	if (p.cmd.buttons & BT_CUSTOM3) and p.speed <= 0 and P_IsObjectOnGround(p.mo) and not p.hugging and not p.mo.blossom_tornado and not p.mo.blossom_duckdance and not p.tanukisuit and not p.mo.blossom_tanukianim then
		if P_RandomChance(FRACUNIT/100) then
			p.mo.blossom_duckdance = 2
			S_PauseMusic(p)
		else
			p.mo.blossom_duckdance = 1
			P_PlayJingleMusic(p, "HEYYA", nil, true, JT_OTHER)
		end

		p.mo.blossom_dancetimer = 1
		p.mo.blossom_waittimer = nil
		p.mo.blossom_isidling = nil
		p.mo.blossom_dothings = nil
	end

	if p.mo.blossom_duckdance then
		p.mo.blossom_dancetimer = $ and $+1 or 1

		if p.speed > 0 or p.mo.blossom_tornado or p.hugging or not P_IsObjectOnGround(p.mo) or p.tanukisuit or p.mo.blossom_tanukianim then
			p.mo.z = $+FRACUNIT
			p.mo.state = S_PLAY_STND
			if p.mo.momz > 0 then p.mo.state = S_PLAY_SPRING end
			if S_SoundPlaying(p.mo, sfx_uigoku) then S_StopSoundByID(p.mo, sfx_uigoku) end
			if p.mo.blossom_duckdance == 2 then S_ResumeMusic(p) end
			p.mo.blossom_duckdance = nil
			P_RestoreMusic(p)
		else
			if p.mo.blossom_duckdance == 2 then
				p.mo.state = S_PLAY_CLIMB
				p.mo.sprite2 = SPR2_CLMB
				p.mo.frame = FF_FULLBRIGHT|A

				if not (leveltime%25) then
					local ghost = P_SpawnGhostMobj(p.mo)
					ghost.destscale = 5*FRACUNIT
				end

				if not S_SoundPlaying(p.mo, sfx_uigoku) then S_StartSound(p.mo, sfx_uigoku) end
			else
				if p.mo.state ~= S_PLAY_BLOSSOM_DUCKDANCE then p.mo.state = S_PLAY_BLOSSOM_DUCKDANCE end

				if p.mo.blossom_flimp and p.mo.blossom_flimp.valid then
					p.mo.blossom_flimp.frame = p.mo.frame+1
				elseif p.mo.blossom_dancetimer > 35 and not (p.mo.blossom_dancetimer%350) then
					local flimp = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.ceilingz, MT_DUMMYOBJ)
					flimp.sprite = SPR_FLIM
					flimp.color = netgame and p.skincolor or SKINCOLOR_SHAMROCK
					flimp.golden = P_RandomChance(FRACUNIT/300)
					flimp.hyper = P_RandomChance(FRACUNIT/4096)
					p.mo.blossom_flimp = flimp
				end

				if (p.cmd.buttons & BT_CUSTOM2) then
					p.mo.blossom_returnflimp = true
					p.blossom_keepflimp = nil
				end
			end
		end
	end

	-- Super Form
	if p.powers[pw_super] then
		if not p.mo.blossom_tornadodust2 then p.mo.blossom_tornadodust2 = {} end

		local dust
		local dist = 16
		if not cv_nopetals.value then
			if not (leveltime%6) then
				local i = P_RandomRange(1, 15)
				dust = P_SpawnMobjFromMobj(p.mo, (dist+10)*cos(p.drawangle+(i*72*ANG1)), (dist+10)*sin(p.drawangle+(i*72*ANG1)), 0, MT_THOK)
				dust.angle = (i*24*ANG1)-ANGLE_90
				dust.offset = i
				dust.upwardz = 5*FRACUNIT
				dust.sprite = SPR_LSTM
				dust.frame = FF_PAPERSPRITE|P_RandomKey(4)
				dust.leaf = true
				dust.fuse = 105
				dust.tics = 105
				dust.color = p.mo.color
				dust.colorized = true
				dust.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP
				dust.height = FRACUNIT
				p.mo.blossom_tornadodust2[#p.mo.blossom_tornadodust2+1] = dust
			end

			if not (leveltime%10) then
				dust = P_SpawnMobjFromMobj(p.mo, P_RandomRange(-60, 60)*FRACUNIT, P_RandomRange(-60, 60)*FRACUNIT, P_RandomRange(35, 75)*FRACUNIT, MT_THOK)
				dust.angle = P_RandomRange(1, 360)*ANG1
				dust.momz = -1*FRACUNIT*P_MobjFlip(p.mo)
				dust.sprite = SPR_LSTM
				dust.frame = FF_PAPERSPRITE|P_RandomKey(4)
				dust.leaf = true
				dust.fuse = 105
				dust.tics = 105
				dust.rollangle = P_RandomKey(360)*ANG1
				dust.flags = $|MF_NOCLIP
				dust.color = p.mo.color
				dust.colorized = true
			elseif p.mo.state == S_PLAY_RUN and not (leveltime%2) then
				dust = P_SpawnMobjFromMobj(p.mo, P_RandomRange(-25, 25)*FRACUNIT, P_RandomRange(-25, 25)*FRACUNIT, P_RandomRange(15, 60)*FRACUNIT, MT_THOK)
				dust.angle = P_RandomRange(1, 360)*ANG1
				dust.momz = -1*FRACUNIT*P_MobjFlip(p.mo)
				dust.sprite = SPR_LSTM
				dust.frame = FF_PAPERSPRITE|P_RandomKey(4)
				dust.leaf = true
				dust.fuse = 105
				dust.tics = 105
				dust.rollangle = P_RandomKey(360)*ANG1
				dust.flags = $|MF_NOCLIP
				dust.color = p.mo.color
				dust.colorized = true
			end
		end

		local newtbl = {}
		local rotoffset = 0
		local rotoffset2 = 0
		for i = 1, #p.mo.blossom_tornadodust2 do
			dust = p.mo.blossom_tornadodust2[i]

			if dust and dust.valid then
				if dust.upwardz < 60*FRACUNIT then
					rotoffset = dist+5
					rotoffset2 = dist+8
					P_MoveOrigin(dust, p.mo.x + rotoffset*cos((leveltime*ANG20)+(dust.offset*rotoffset2*ANG1)), p.mo.y + rotoffset*sin((leveltime*ANG20)+(dust.offset*rotoffset2*ANG1)), p.mo.z + dust.upwardz)
					dust.upwardz = $+FRACUNIT
					dust.angle = R_PointToAngle2(dust.x, dust.y, p.mo.x, p.mo.y)-ANGLE_90

					if dust.upwardz >= 25*FRACUNIT then
						dust.momx = p.mo.momx
						dust.momy = p.mo.momy
						dust.momz = p.mo.momz
						dust.tics = 5
						dust.fuse = 5
					end
				end
			end
		end
	-- "bug"
	elseif (not p.mo.targvine) and p.mo.gotovine then 
		if not p.mo.blossom_tornadodust2 then p.mo.blossom_tornadodust2 = {} end

		local dust
		local dist = 16
		if not cv_nopetals.value then
			if not (leveltime%6) then
				local i = P_RandomRange(1, 15)
				dust = P_SpawnMobjFromMobj(p.mo, (dist+10)*cos(p.drawangle+(i*72*ANG1)), (dist+10)*sin(p.drawangle+(i*72*ANG1)), 0, MT_THOK)
				dust.angle = (i*24*ANG1)-ANGLE_90
				dust.offset = i
				dust.upwardz = 5*FRACUNIT
				dust.sprite = SPR_LSTM
				dust.frame = FF_PAPERSPRITE|P_RandomKey(4)
				dust.leaf = true
				dust.fuse = 105
				dust.tics = 105
				dust.color = p.mo.color
				dust.colorized = true
				dust.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP
				dust.height = FRACUNIT
				p.mo.blossom_tornadodust2[#p.mo.blossom_tornadodust2+1] = dust
			end
		end

		local newtbl = {}
		local rotoffset = 0
		local rotoffset2 = 0
		for i = 1, #p.mo.blossom_tornadodust2 do
			dust = p.mo.blossom_tornadodust2[i]

			if dust and dust.valid then
				if dust.upwardz < 60*FRACUNIT then
					rotoffset = dist+5
					rotoffset2 = dist+8
					P_MoveOrigin(dust, p.mo.x + rotoffset*cos((leveltime*ANG20)+(dust.offset*rotoffset2*ANG1)), p.mo.y + rotoffset*sin((leveltime*ANG20)+(dust.offset*rotoffset2*ANG1)), p.mo.z + dust.upwardz)
					dust.upwardz = $+FRACUNIT
					dust.angle = R_PointToAngle2(dust.x, dust.y, p.mo.x, p.mo.y)-ANGLE_90

					if dust.upwardz >= 25*FRACUNIT then
						dust.momx = p.mo.momx
						dust.momy = p.mo.momy
						dust.momz = p.mo.momz
						dust.tics = 5
						dust.fuse = 5
					end
				end
			end
		end
	end
end)

rawset(_G, "Blossom_PostThink", function(p)
	if p.mo.blossom_tanukianim and p.mo.blossom_tanukianim > 1 then
		p.mo.sprite = SPR_DUST
		p.mo.frame = FF_FULLBRIGHT|A
	elseif p.tanukisuit then
		p.mo.sprite = SPR_PLAY
		p.mo.state = S_PLAY_STND
		p.mo.color = SKINCOLOR_SILVER
		p.mo.colorized = true
	end

	if p.mo.skin ~= "blossom" then return end
end)