// HYPERSPEED
local function combopreserve(mo)
	return mo.blossom_tornado
end

addHook("ThinkFrame", do
	if hyperspeed_combopreserve then hyperspeed_combopreserve["blossom"] = combopreserve end
end)

// Kirby
if not kirbyabilitytable then rawset(_G, "kirbyabilitytable", {}) end
kirbyabilitytable["blossom"] = 6

// BattleMod
// Adapted from CobaltBW's example lua.
local ScriptLoaded = false

addHook("ThinkFrame", do
	if not(ScriptLoaded) and CBW_Battle then
		ScriptLoaded = true
		local B = CBW_Battle
				
		local TornadoLash = function(mo, doaction)
			local player = mo.player
			player.actiontext = "Tornado Burst"
			player.actionrings = 10

			if not B.CanDoAction(player) then player.actionstate = 0 return end	

			if player.actionstate == 0 and doaction == 1 then
				player.actionstate = 1
				player.actiontime = 0
				B.PayRings(player)
				S_StartSound(mo, sfx_s3k3c)
			elseif player.actionstate == 1 then
				player.actiontime = $+1

				P_InstaThrust(mo, mo.angle, 0)
				P_SetObjectMomZ(mo, 0)

				player.pflags = ($|PF_SPINNING)&~PF_JUMPED
				mo.state = S_PLAY_BLOSSOM_TORNADO
				P_SpawnThokMobj(player)

				if player.actiontime == 5 then
					player.actionstate = 2
					player.actiontime = 0

					P_InstaThrust(mo, mo.angle, 0)
					P_SetObjectMomZ(mo, P_MobjFlip(mo)*6*mo.scale)
					S_StartSound(mo, sfx_grass2)

					local dust
					for i = 1, 10 do
						dust = P_SpawnMobjFromMobj(mo, 16*cos(player.drawangle+(i*36*ANG1)), 16*sin(player.drawangle+(i*36*ANG1)), 0, MT_DUSTLAYER)
						dust.angle = (i*36*ANG1)-ANGLE_90
						dust.offset = i
						dust.upwardz = 5*FRACUNIT
						dust.tics = 105
						dust.fuse = 105
						dust.color = color or SKINCOLOR_GREY
						dust.colorized = colorize or false
						dust.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP
						dust.height = FRACUNIT

						P_InstaThrust(dust, R_PointToAngle2(mo.x, mo.y, dust.x, dust.y), 15*FRACUNIT)
					end
				end
			elseif player.actionstate == 2 then
				player.actiontime = $+1

				if player.actiontime <= 5 then
					local dist = (200 + player.actiontime*5)*FRACUNIT
					searchBlockmap("objects", function(pmo, mobj)
						if mobj.z < pmo.z + (90 + player.actiontime)*FRACUNIT and mobj.z > pmo.z - (30 - player.actiontime/2)*FRACUNIT and mobj ~= pmo then
							if mobj.player and CBW_Battle and not CBW_Battle.MyTeam(pmo, mobj) then
								if CBW_Battle.GuardTrigger(pmo, mobj, mobj.target, 1, 0) then
									P_InstaThrust(pmo, R_PointToAngle2(mobj.x, mobj.y, pmo.x, pmo.y), 15*FRACUNIT)
									pmo.state = S_PLAY_PAIN
								else
									P_DamageMobj(mobj, pmo, pmo)
								end
							elseif not mobj.player then
								if (mobj.flags == MT_METALSONIC_BATTLE) then
									if mobj.state == mobj.info.spawnstate then
										mobj.movedir = ANGLE_11hh - FixedAngle(FixedMul(AngleFixed(ANGLE_11hh), FixedDiv((mobj.info.spawnhealth - mobj.health) << FRACBITS, (mobj.info.spawnhealth - 1) << FRACBITS)))
										if P_RandomChance(FRACUNIT / 2) then movedir = InvAngle(mobj.movedir) end
										mobj.threshold = 6 + (FixedMul(24 << FRACBITS, FixedDiv((mobj.info.spawnhealth - mobj.health) << FRACBITS, (mobj.info.spawnhealth - 1) << FRACBITS)) >> FRACBITS)
										S_StartSound(mobj, mobj.info.activesound)
										mobj.state = mobj.info.painchance
										mobj.flags2 = $ & ~MF2_INVERTAIMABLE
									end
								elseif (mobj.flags & MF_SHOOTABLE) then
									if (mobj.flags & MF_ENEMY or mobj.flags & MF_BOSS) then
										P_DamageMobj(mobj, pmo, pmo)
									else
										P_KillMobj(mobj, pmo, pmo)
									end
								end
							end
						end
					end, player.mo, player.mo.x-dist, player.mo.x+dist, player.mo.y-dist, player.mo.y+dist)
				end

				if player.actiontime == 20 then
					player.actionstate = 0
					B.ApplyCooldown(player, 2*TICRATE)
				end
			end
		end

		local PriorityFunc = function(player)
			if player.actionstate == 1 then B.SetPriority(player, 2, 4, nil, 1, 3, "tornado spin") end
		end

		local ExhaustFunc = function(player)
			if player.mo.state == S_PLAY_BLOSSOM_TORNADO then
				local maxtime = 7*TICRATE
				player.exhaustmeter = max(0,$-FRACUNIT/maxtime)

				if player.exhaustmeter <= 0 then
					player.pflags = $ & ~(PF_STARTDASH|PF_SPINNING)
					player.mo.state = S_PLAY_STND
				end

				return true
			end

			return false
		end

		CBW_Battle.SkinVars["blossom"] = {
			special = TornadoLash,
			func_priority_ext = PriorityFunc,
			func_exhaust = ExhaustFunc,
		}
	end
end)
