local function tornadoAnim(p, mo)
	if not mo or not mo.valid then return end

	local dust
	local dist = 60
	local color = p.skincolor
	local colorize = false

	if p.powers[pw_super] then
		color = p.mo.color
		colorize = true
	elseif hasShield(p, SH_ARMAGEDDON) then
		dist = 120
		color = SKINCOLOR_RED
		colorize = true
	elseif hasShield(p, SH_ATTRACT) then
		color = SKINCOLOR_YELLOW
		colorize = true
	elseif (p.powers[pw_shield] & SH_FORCE) then
		color = SKINCOLOR_PURPLE
		colorize = true
	end

	if not mo.blossom_tornadodust then
		mo.blossom_tornadodust = {}

		for i = 1, 5 do
			dust = P_SpawnMobjFromMobj(mo, dist*FixedMul(p.mo.scale, cos(p.drawangle+(i*72*ANG1))), dist*FixedMul(p.mo.scale, sin(p.drawangle+(i*72*ANG1))), 0, MT_DUSTLAYER)
			dust.angle = (i*72*ANG1)-ANGLE_90
			dust.offset = i
			dust.upwardz = 5*FRACUNIT
			dust.tics = 105
			dust.fuse = 105
			dust.color = color or SKINCOLOR_GREY
			dust.colorized = colorize or false
			dust.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP
			dust.height = FRACUNIT
			mo.blossom_tornadodust[#mo.blossom_tornadodust+1] = dust
		end

		if not cv_nopetals.value then
			local i = P_RandomRange(1, 15)
			dust = P_SpawnMobjFromMobj(mo, (dist+10)*FixedMul(p.mo.scale, cos(p.drawangle+(i*72*ANG1))), (dist+10)*FixedMul(p.mo.scale, sin(p.drawangle+(i*72*ANG1))), 0, MT_THOK)
			dust.angle = (i*24*ANG1)-ANGLE_90
			dust.offset = i
			dust.upwardz = 5*FRACUNIT
			dust.sprite = SPR_LSTM
			dust.frame = FF_PAPERSPRITE|P_RandomKey(4)
			dust.leaf = true
			dust.fuse = 105
			dust.tics = 105
			dust.color = color or SKINCOLOR_GREY 
			dust.colorized = colorize or false
			dust.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP
			dust.height = FRACUNIT

			if mo.player and mo.player.tanukisuit then
				dust.sprite = SPR_ROIB
				dust.frame = P_RandomKey(7)
			end

			mo.blossom_tornadodust[#mo.blossom_tornadodust+1] = dust
		end
	else
		if not (leveltime%5) then
			local i = P_RandomRange(1, 5)
			dust = P_SpawnMobjFromMobj(mo, dist*FixedMul(p.mo.scale, cos(p.drawangle+(i*72*ANG1))), dist*FixedMul(p.mo.scale, sin(p.drawangle+(i*72*ANG1))), 0, MT_DUSTLAYER)
			dust.angle = (i*72*ANG1)-ANGLE_90
			dust.offset = i
			dust.upwardz = 3*FRACUNIT
			dust.tics = 105
			dust.fuse = 105
			dust.color = color or SKINCOLOR_GREY
			dust.colorized = colorize or false
			dust.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP
			dust.height = FRACUNIT
			mo.blossom_tornadodust[#mo.blossom_tornadodust+1] = dust
		end

		if not cv_nopetals.value then
			local i = P_RandomRange(1, 15)
			dust = P_SpawnMobjFromMobj(mo, (dist+10)*FixedMul(p.mo.scale, cos(p.drawangle+(i*72*ANG1))), (dist+10)*FixedMul(p.mo.scale, sin(p.drawangle+(i*72*ANG1))), 0, MT_THOK)
			dust.angle = (i*24*ANG1)-ANGLE_90
			dust.offset = i
			dust.upwardz = 5*FRACUNIT
			dust.sprite = SPR_LSTM
			dust.frame = FF_PAPERSPRITE|P_RandomKey(4)
			dust.leaf = true
			dust.fuse = 105
			dust.tics = 105
			dust.color = color or SKINCOLOR_GREY
			dust.colorized = colorize or false
			dust.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOBLOCKMAP
			dust.height = FRACUNIT

			if mo.player and mo.player.tanukisuit then
				dust.sprite = SPR_ROIB
				dust.frame = P_RandomKey(7)
			end

			mo.blossom_tornadodust[#mo.blossom_tornadodust+1] = dust
		end
	end

	if mo.blossom_tornadomobjs and #mo.blossom_tornadomobjs then
		local flingmobjs = mo.blossom_tornadomobjs

		local x, ang, zoff, mobj
		local targx, targy, targz
		for i = 1, #flingmobjs do
			mobj = flingmobjs[i][4]

			if mobj and mobj.valid then
				mo.blossom_tornadomobjs[i][2] = $ + (ANG2*6)
				mo.blossom_tornadomobjs[i][3] = min(60*FRACUNIT, $ + 2*FRACUNIT)
				mobj.rollangle = $+ANG10

				targx = p.mo.x + FixedMul(p.mo.scale, FixedMul(mo.blossom_tornadomobjs[i][1], cos(mo.blossom_tornadomobjs[i][2])))
				targy = p.mo.y + FixedMul(p.mo.scale, FixedMul(mo.blossom_tornadomobjs[i][1], sin(mo.blossom_tornadomobjs[i][2])))
				targz = p.mo.z + FixedMul(mo.blossom_tornadomobjs[i][3], p.mo.scale)

				mobj.some_momentums = {(targx - mobj.x)/2, (targy - mobj.y)/2, 8*FRACUNIT}
				mobj.blossom_inflictor = mo
				P_MoveOrigin(mobj, targx, targy, targz)
			end
		end
	end

	local i = 1
	local newtbl = {}
	local rotoffset = 0
	local rotoffset2 = 0
	while mo.blossom_tornadodust[i] do
		dust = mo.blossom_tornadodust[i]

		if dust and dust.valid then
			if dust.upwardz < 60*FRACUNIT then
				rotoffset = dust.leaf and dist+10 or dist
				rotoffset2 = dust.leaf and dist-30 or dist+12
				P_MoveOrigin(dust, mo.x + rotoffset*FixedMul(p.mo.scale, cos(p.drawangle+(dust.offset*rotoffset2*ANG1))), mo.y + rotoffset*FixedMul(p.mo.scale, sin(p.drawangle+(dust.offset*rotoffset2*ANG1))), mo.z + FixedMul(p.mo.scale, dust.upwardz))
				dust.upwardz = $ + (dust.leaf and 3*FRACUNIT or FRACUNIT)
				dust.angle = R_PointToAngle2(dust.x, dust.y, p.mo.x, p.mo.y)-ANGLE_90

				if not dust.leaf and not camera.chase then
					dust.flags2 = $|MF2_DONTDRAW
				else
					dust.flags2 = $ & ~MF2_DONTDRAW
				end

				if dust.upwardz >= 60*FRACUNIT then
					if not dust.leaf then
						P_RemoveMobj(dust)
					else
						dust.momx = mo.momx
						dust.momy = mo.momy
						dust.momz = mo.momz
					end
				end
			end

			i = $+1
		else
			table.remove(mo.blossom_tornadodust, i)
		end
	end

	-- Dust Devil effect. Spawn bubbles underwater instead.
	local targz = mo.floorz
	if mo.eflags & MFE_VERTICALFLIP then targz = mo.ceilingz end

	if (abs(mo.z - targz) < 160*mo.scale) then
		local bubbles
		for fof in mo.subsector.sector.ffloors() do
			if (fof.flags & FF_EXISTS|FF_SWIMMABLE) == (FF_EXISTS|FF_SWIMMABLE) and fof.topheight > targz and fof.bottomheight < targz
				bubbles = true
			end
		end

		local dustang = P_RandomRange(0, 7)*ANGLE_45

		if bubbles then
			dust = P_SpawnMobj(mo.x + 90*FixedMul(mo.scale, cos(dustang)), mo.y + 90*FixedMul(mo.scale, sin(dustang)), targz, MT_THOK)
			dust.state = S_SPINDUST_BUBBLE1
			dust.scale = 5*mo.scale/2 + (mo.scale/4)
			dust.destscale = 1
		else
			dust = P_SpawnMobj(mo.x + 90*FixedMul(mo.scale, cos(dustang)), mo.y + 90*FixedMul(mo.scale, sin(dustang)), targz, MT_ARIDDUST)
			dust.state = dust.info.spawnstate + P_RandomRange(0, 2)
			dust.scale = 5*mo.scale/2 + (mo.scale/4)
			dust.destscale = 1
		end
	end
end

-- Tornado Slam fof busting.
local function bustAndRunExecutor(mo, fof)
	local line = fof.master

	EV_CrumbleChain(fof)
	if line.flags & ML_EFFECT5
		P_LinedefExecute(P_AproxDistance(line.dx, line.dy) >> FRACBITS, mo, fof.target)
	end
end

rawset(_G, "tornadoBust", function(p)
	local sector = p.mo.subsector.sector
		
	for fof in sector.ffloors()
		if fof.flags & (FF_EXISTS|FF_BUSTUP) ~= (FF_EXISTS|FF_BUSTUP) then continue end

		local t
		local b

		if fof.t_slope then t = P_GetZAt(fof.t_slope, x, y) else t = fof.topheight end
		if fof.b_slope then b = P_GetZAt(fof.bottomslope, x, y) else b = fof.bottomheight end
		
		if p.mo.z-(p.mo.height/3) < t 
		and (p.mo.z > b)
			bustAndRunExecutor(p.mo, fof)
		end
	end
end)

-- Tornado damage function
local function tornadoDamage(pmo, mobj)
	if mobj.z < pmo.z + 90*FRACUNIT and mobj.z > pmo.z - 30*FRACUNIT and mobj ~= pmo then
		if mobj.player and CBW_Battle and not CBW_Battle.MyTeam(pmo, mobj) then
			if CBW_Battle.GuardTrigger(pmo, mobj, mobj.target, 1, 0) then
				P_InstaThrust(pmo, R_PointToAngle2(mobj.x, mobj.y, pmo.x, pmo.y), 15*FRACUNIT)
				P_SetObjectMomZ(pmo, 7*FRACUNIT)
				pmo.state = S_PLAY_PAIN
				pmo.blossom_tornado = nil
			else
				P_DamageMobj(mobj, pmo, pmo)
			end
		elseif not mobj.player then
			if (mobj.flags == MT_METALSONIC_BATTLE) then
				if mobj.state == mobj.info.spawnstate then
					mobj.movedir = ANGLE_11hh - FixedAngle(FixedMul(AngleFixed(ANGLE_11hh), FixedDiv((mobj.info.spawnhealth - mobj.health) << FRACBITS, (mobj.info.spawnhealth - 1) << FRACBITS)))
					if P_RandomChance(FRACUNIT / 2) then movedir = InvAngle(mobj.movedir) end
					mobj.threshold = 6 + (FixedMul(24 << FRACBITS, FixedDiv((mobj.info.spawnhealth - mobj.health) << FRACBITS, (mobj.info.spawnhealth - 1) << FRACBITS)) >> FRACBITS)
					S_StartSound(mobj, mobj.info.activesound)
					mobj.state = mobj.info.painchance
					mobj.flags2 = $ & ~MF2_INVERTAIMABLE
				end
			elseif (mobj.flags & MF_SHOOTABLE) then
				if (mobj.flags & MF_ENEMY or mobj.flags & MF_BOSS) then
					P_DamageMobj(mobj, pmo, pmo)
				else
					P_KillMobj(mobj, pmo, pmo)
				end
			end
		end
	end
end

local function attractShield(pmo, mobj)
	local p = pmo.player
	if (mobj.z < pmo.z + 300*pmo.scale) and (mobj.z > pmo.z - 300*pmo.scale) and (mobj.flags & MF_ENEMY) then
		if not (leveltime%2) then
			local thok = P_SpawnMobjFromMobj(mobj, P_RandomRange(-60, 60)*FRACUNIT, P_RandomRange(-60, 60)*FRACUNIT, P_RandomRange(-60, 60)*FRACUNIT, MT_DUMMYOBJ)
			thok.sprite = SPR_WZAP
			thok.frame = FF_FULLBRIGHT|A
			thok.color = SKINCOLOR_GOLD
			thok.colorized = true
			thok.tics = 10
			thok.fuse = 10
			thok.scale = 3*FRACUNIT
			thok.destscale = 1

			local dist = P_AproxDistance(P_AproxDistance(pmo.x - thok.x, pmo.y - thok.y), pmo.z - thok.z)
			thok.momx = FixedMul(FixedDiv(pmo.x - thok.x, dist), 30*FRACUNIT)
			thok.momy = FixedMul(FixedDiv(pmo.y - thok.y, dist), 30*FRACUNIT)
			thok.momz = FixedMul(FixedDiv(pmo.z - thok.z, dist), 30*FRACUNIT)

			if not S_SoundPlaying(mobj, sfx_s3k5c) then S_StartSound(mobj, sfx_s3k5c) end
		end

		mobj.momx = $ + (pmo.x - mobj.x)/60
		mobj.momy = $ + (pmo.y - mobj.y)/60
		mobj.momz = $ + (pmo.z - mobj.z)/60
	end
end

local function releaseMobjs(mo)
	if mo.blossom_tornadomobjs and #mo.blossom_tornadomobjs then
		S_StartSound(mo, sfx_s3k51)

		local flingmobjs = mo.blossom_tornadomobjs
		local targetted = {}

		local mobj
		for i = 1, #flingmobjs do
			mobj = flingmobjs[i][4]

			if mobj and mobj.valid then
				mobj.momx, mobj.momy, mobj.momz = unpack(mobj.some_momentums)
				mobj.flags = MF_MISSILE
				mobj.target = mo
			end
		end
	end

	mo.blossom_tornadomobjs = nil
end

-- j
local shieldChanges = {
	[SH_WHIRLWIND] = function(p)
		if (p.mo.eflags & MFE_VERTICALFLIP and p.mo.momz >= -15*p.mo.scale) or (p.mo.momz <= 15*p.mo.scale) then
			P_SetObjectMomZ(p.mo, 5*FRACUNIT/2, true)
			p.pflags = $|PF_CANCARRY
		end
	end
}

-- Spin Specials
addHook("SpinSpecial", function(p)
	if srb2p then return end -- lets not
	if not p.mo or not p.mo.valid then return end
	if p.mo.skin ~= "blossom" then return end
	if p.mo.blossom_didsuper_horizontal then return end
	if p.mo.blossom_tornado then return end
	if p.mo.blossom_didtornado then return end
	if p.mo.targvine and ((p.mo.targvine[4] and p.mo.targvine[4].valid) or p.mo.targvine[1].hitwall) then return end
	if p.mo.blossom_fastfall then return end
	if p.notornado or p.notornadogrounded then return end
	if P_PlayerInPain(p) then return end
	if p.exiting then return true end
	if p.mo.blossom_didtwirl then return end
	if p.mo.buttons.spin >= 10 then return end
	if p.mo.blossom_tornado_cool then return end

	if All7Emeralds(emeralds) and (p.rings >= 50) and (p.powers[pw_shield] == SH_NONE) and not p.powers[pw_super] then
		P_DoSuperTransformation(p)
		return true
	end

	if p.mo.targvine and p.mo.targvine[3] <= 25 and not (p.mo.targvine[4] and p.mo.targvine[4].valid) and not p.mo.targvine[1].hitwall then
		p.mo.targvine[3] = min(20, $)
		p.mo.blossom_tornado = 70
		p.mo.blossom_didtornado = true
		S_StartSound(p.mo, sfx_grass1)
		return true
	end

	p.mo.blossom_tornado = 70
	p.mo.blossom_grounded = P_IsObjectOnGround(p.mo)
	p.mo.blossom_didtornado = true
	S_StartSound(p.mo, sfx_grass1)
	return true
end)

rawset(_G, "Blossom_Tornado", function(p)
	if srb2p then return end -- lets not
	if not (p.cmd.buttons & BT_SPIN) then p.notornado = nil end

	-- Cooldown
	if p.mo.blossom_tornado_cool then
		p.mo.blossom_tornado_cool = $-1
		if p.mo.blossom_tornado_cool <= 0 then p.mo.blossom_tornado_cool = nil end
	end

	-- Air Twirl
	if p.mo.blossom_didtwirl then
		p.mo.blossom_didtwirl = $-1
		if p.mo.blossom_didtwirl <= 0 then p.mo.blossom_didtwirl = nil end
	end

	if p.mo.blossom_twirltimer then
		if p.mo.state ~= S_PLAY_BLOSSOM_TORNADO then p.mo.state = S_PLAY_BLOSSOM_TORNADO end
		p.mo.blossom_twirltimer = $-1

		if p.mo.buttons.jump > 0 and not (p.mo.eflags & MFE_GOOWATER) then
			p.drawangle = p.mo.angle
			p.mo.blossom_fastfall = true
			p.mo.blossom_grounded = nil
			p.mo.blossom_tornado = nil
			p.mo.blossom_cancelled = nil
			S_StartSound(p.mo, sfx_s3k51)
			p.mo.blossom_twirltimer = nil
			return
		end

		if p.mo.blossom_twirltimer <= 0 then
			p.mo.state = S_PLAY_FALL
			p.mo.blossom_twirltimer = nil
		end
	end

	if p.notornadogrounded and p.mo.buttons.jump > 0 and p.mo.buttons.spin > 0 then
		p.drawangle = p.mo.angle
		p.mo.blossom_fastfall = true
		p.pflags = $ & ~PF_SPINNING
		p.mo.blossom_grounded = nil
		p.mo.blossom_tornado = nil
		p.mo.blossom_cancelled = nil
		p.notornadogrounded = nil
		p.notornado = nil
		p.mo.blossom_cancelled = nil
		p.mo.blossom_didtwirl = nil
		p.mo.blossom_twirltimer = nil
		p.pflags = $ & ~PF_CANCARRY
		S_StartSound(p.mo, sfx_s3k51)
	end

	if p.mo.spin_stuff then
		if p.mo.state ~= S_PLAY_BLOSSOM_TORNADO then p.mo.state = S_PLAY_BLOSSOM_TORNADO end
		p.pflags = $|PF_SPINNING

		if (not P_IsObjectOnGround(p.mo)) or P_PlayerInPain(p) or p.playerstate == PST_DEAD or p.speed <= 5*FRACUNIT or p.mo.blossom_tornado then
			p.mo.spin_stuff = nil
			p.drawangle = p.mo.angle
			p.mo.blossom_cancelled = nil
			p.mo.state = P_IsObjectOnGround(p.mo) and S_PLAY_STND or S_PLAY_FALL
			p.pflags = $ & ~PF_SPINNING
		end
	end

	if p.mo.blossom_cancelled then
		if not cv_nopetals.value then
			local dust = P_SpawnMobjFromMobj(p.mo, P_RandomRange(-60, 60)*FRACUNIT, P_RandomRange(-60, 60)*FRACUNIT, P_RandomRange(0, 70)*FRACUNIT, MT_THOK)
			dust.angle = P_RandomRange(1, 360)*ANG1
			dust.upwardz = 5*FRACUNIT*P_MobjFlip(p.mo)
			dust.momz = 5*FRACUNIT*P_MobjFlip(p.mo)
			dust.sprite = SPR_LSTM
			dust.frame = FF_PAPERSPRITE|P_RandomKey(4)
			dust.leaf = true
			dust.fuse = 105
			dust.tics = 105
			dust.flags = $|MF_NOCLIP
			dust.color = p.skincolor

			if p.tanukisuit then
				dust.sprite = SPR_ROIB
				dust.frame = P_RandomKey(7)
				dust.color = SKINCOLOR_GREY
			elseif p.powers[pw_super] then
				dust.color = p.mo.color
				dust.colorized = true
			end
		end

		if p.mo.buttons.jump > 0 and p.mo.buttons.spin > 0 then
			p.drawangle = p.mo.angle
			p.mo.blossom_fastfall = true
			p.pflags = $ & ~PF_SPINNING
			p.mo.blossom_grounded = nil
			p.mo.blossom_tornado = nil
			p.mo.blossom_cancelled = nil
			p.pflags = $ & ~PF_CANCARRY
			S_StartSound(p.mo, sfx_s3k51)
		end
	end

	if p.mo.blossom_fastfall then
		p.mo.blossom_grounded = nil
		p.mo.blossom_tornado = nil
		p.mo.blossom_cancelled = nil
		if p.mo.state ~= S_PLAY_BLOSSOM_TORNADO then p.mo.state = S_PLAY_BLOSSOM_TORNADO end

		if hasShield(p, SH_ELEMENTAL) then
			p.pflags = $|PF_SHIELDABILITY
		end

		p.mo.momz = $-((3*p.mo.scale)*P_MobjFlip(p.mo))
		p.mo.spritexscale = min(FRACUNIT, (max(FRACUNIT/5, FRACUNIT - (abs(p.mo.momz)/20))))
		p.mo.spriteyscale = max(FRACUNIT, min(5*FRACUNIT, abs(p.mo.momz)/20))

		if not p.mo.blossom_fallingz or p.mo.blossom_fallingz < abs(p.mo.momz/2) then
			p.mo.blossom_fallingz = abs(p.mo.momz/2)
		end

		p.powers[pw_strong] = STR_SPRING
		p.mo.blossom_autospringremove = 5

		local ghost = P_SpawnGhostMobj(p.mo)
		ghost.spritexscale = p.mo.spritexscale
		ghost.spriteyscale = p.mo.spriteyscale
		ghost.tics = 5
		ghost.fuse = 5
		ghost.blendmode = AST_ADD

		tornadoBust(p)

		if (p.mo.eflags & MFE_GOOWATER) then
			p.mo.spritexscale = FRACUNIT
			p.mo.spriteyscale = FRACUNIT
			S_StartSound(p.mo, sfx_s3k49)
			P_SetObjectMomZ(p.mo, -20*FRACUNIT, true)

			local goop
			for i = 1, 16 do
				goop = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_SPINDUST)
				P_InstaThrust(goop, i*ANGLE_22h, 18*FRACUNIT)
--				P_SetObjectMomZ(goop, 10*FRACUNIT)

				goop.color = SKINCOLOR_LAVENDER
				goop.colorized = true
			end

			p.mo.blossom_fastfall = nil
			p.pflags = $ & ~PF_SHIELDABILITY
		end

		if P_IsObjectOnGround(p.mo) then
			p.mo.spritexscale = FRACUNIT
			p.mo.spriteyscale = FRACUNIT

			if (p.cmd.buttons & BT_SPIN) then
				local func = (p.gigathrust or p.powers[pw_super]) and P_Thrust or P_InstaThrust

				if hasShield(p, SH_ELEMENTAL) then
					P_ElementalFire(p, true)
					func(p.mo, p.mo.angle, max(50*p.mo.scale, p.speed + 5*p.mo.scale) + p.mo.blossom_fallingz)
					S_StartSound(p.mo, sfx_zoom)
				elseif hasShield(p, SH_THUNDERCOIN) then
					func(p.mo, p.mo.angle, max(60*p.mo.scale, p.speed + 15*p.mo.scale) + p.mo.blossom_fallingz)
					S_StartSound(p.mo, sfx_s3k45)
					S_StartSound(p.mo, sfx_zoom)
				else
					func(p.mo, p.mo.angle, max(50*p.mo.scale, p.speed + 5*p.mo.scale) + p.mo.blossom_fallingz)
					S_StartSound(p.mo, sfx_zoom)
				end

				p.mo.state = S_PLAY_BLOSSOM_TORNADO
				p.pflags = $|PF_SPINNING
				p.mo.spin_stuff = true
				p.notornado = true
			else
				S_StartSound(p.mo, sfx_s3k49)
				p.notornadogrounded = true

				if hasShield(p, SH_ELEMENTAL) then
					P_ElementalFire(p, true)
					P_SetObjectMomZ(p.mo, 9*FRACUNIT, true)
				elseif hasShield(p, SH_BUBBLEWRAP) then
					P_SetObjectMomZ(p.mo, 20*FRACUNIT, true)
					S_StartSound(p.mo, sfx_s3k44)

					local bubble
					for i = 1, 16 do
						bubble = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_DUMMYOBJ)
						P_InstaThrust(bubble, i*(ANG10+ANG2*3), 6*FRACUNIT)
						bubble.sprite = SPR_BUBL
						bubble.frame = D
						bubble.momz = 2*FRACUNIT
						bubble.fuse = 17
						bubble.destscale = 1
					end
				else
					P_SetObjectMomZ(p.mo, 9*FRACUNIT, true)

					local spindust
					for i = 1, 16 do
						spindust = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_SPINDUST)
						P_InstaThrust(spindust, i*ANGLE_22h, 15*FRACUNIT)
					end
				end
			end

			p.mo.blossom_fastfall = nil
			p.mo.blossom_fallingz = nil
			p.pflags = $ & ~PF_SHIELDABILITY
		end
	end

	if p.mo.blossom_tornado then
		if hasShield(p, SH_THUNDERCOIN) then
			p.mo.flags2 = $|MF2_DONTDRAW
			p.mo.blossom_tornado = $-1

			local thok
			if p.mo.funnyThok and p.mo.funnyThok.valid then
				thok = p.mo.funnyThok
				P_MoveOrigin(thok, p.mo.x, p.mo.y, p.mo.z)
			else
				thok = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_THOK)
				thok.scale = 7*p.mo.scale/8
				thok.color = SKINCOLOR_WHITE
				thok.colorized = true
				thok.frame = FF_FULLBRIGHT|A
				thok.spriteyscale = (p.mo.blossom_tornado <= 60) and 5*FRACUNIT/2 or FRACUNIT
				thok.tics = 30
				thok.fuse = 30

				p.mo.funnyThok = thok
			end

			thok = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_THOK)
			thok.color = p.skincolor
			thok.colorized = true
			thok.frame = FF_FULLBRIGHT|FF_TRANS20|A
			thok.blendmode = AST_ADD
			thok.tics = 40
			thok.fuse = 40
			thok.destscale = 1
			thok.scalespeed = FRACUNIT/20
			thok.spriteyscale = (p.mo.blossom_tornado <= 60) and 5*FRACUNIT/2 or FRACUNIT

			if p.mo.buttons.jump == 1 and not (p.mo.eflags & MFE_GOOWATER) then
				S_StartSound(p.mo, sfx_s3ka6)
				p.mo.flags2 = $ & ~MF2_DONTDRAW
				p.shieldscale = FRACUNIT

				if p.mo.funnyThok and p.mo.funnyThok.valid then
					thok = p.mo.funnyThok
					thok.destscale = 3*FRACUNIT
					thok.tics = 10
					thok.fuse = 10
				end

				p.drawangle = p.mo.angle
				p.mo.blossom_fastfall = true
				p.pflags = $ & ~PF_SPINNING
				p.mo.blossom_grounded = nil
				p.mo.blossom_tornado = nil
				p.mo.funnyThok = nil
				S_StartSound(p.mo, sfx_s3k51)
				P_SetObjectMomZ(p.mo, 5*FRACUNIT)
				return
			end

			p.mo.blossom_tornado = $-1
			if p.mo.momz <= -FRACUNIT then p.mo.momz = -FRACUNIT end

			if p.mo.blossom_tornado == 60 then
				S_StartSound(p.mo, sfx_s3k45)

				local spark
				for i = 1, 16 do
					spark = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_THUNDERCOIN_SPARK)
					spark.momx, spark.momy, spark.momz = 10*cos(((ANG10*36)/16)*i), 10*sin(((ANG10*36)/16)*i), -5*FRACUNIT
					spark.fuse = 31
				end
			end

			if p.mo.blossom_tornado <= 60 then
				p.shieldscale = 1
				P_SetObjectMomZ(p.mo, 43*FRACUNIT)

				thok = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_THOK)
				thok.sprite = SPR_WZAP
				thok.frame = FF_FULLBRIGHT|A
				thok.color = SKINCOLOR_WHITE
				thok.colorized = true
				thok.momx = P_RandomRange(-5, 5)*FRACUNIT
				thok.momy = P_RandomRange(-5, 5)*FRACUNIT
				thok.momz = P_RandomRange(-5, 5)*FRACUNIT
			end

			if p.mo.blossom_tornado <= 48 then
				P_SetObjectMomZ(p.mo, 10*FRACUNIT)
				S_StartSound(p.mo, sfx_s3ka6)
				p.mo.flags2 = $ & ~MF2_DONTDRAW
				p.shieldscale = FRACUNIT

				if p.mo.funnyThok and p.mo.funnyThok.valid then
					thok = p.mo.funnyThok
					thok.destscale = 3*FRACUNIT
					thok.tics = 10
					thok.fuse = 10
				end

				p.pflags = $ & ~PF_SPINNING
				p.mo.state = p.mo.blossom_grounded and S_PLAY_STND or S_PLAY_FALL
				p.mo.blossom_grounded = nil
				p.mo.blossom_tornado = nil
				p.mo.funnyThok = nil
			end
		else
			if p.mo.state ~= S_PLAY_BLOSSOM_TORNADO then p.mo.state = S_PLAY_BLOSSOM_TORNADO end
			p.drawangle = p.mo.angle+(p.mo.blossom_tornado*ANG20)

			if p.mo.buttons.jump == 1 and not (p.mo.eflags & MFE_GOOWATER) then
				p.drawangle = p.mo.angle
				p.mo.blossom_fastfall = true
				p.pflags = $ & ~PF_SPINNING
				p.mo.blossom_grounded = nil
				p.mo.blossom_tornado = nil
				p.pflags = $ & ~PF_CANCARRY
				S_StartSound(p.mo, sfx_s3k51)

				local sound = p.tanukisuit and sfx_rocks1 or sfx_s3kcel
				if S_SoundPlaying(p.mo, sound) then S_StopSoundByID(p.mo, sound) end
				if hasShield(p, SH_ATTRACT) then releaseMobjs(p.mo) end

				return
			elseif p.mo.buttons.spin == 1 and p.mo.blossom_tornado <= 65 and not p.mo.blossom_cancelled then
				if p.mo.blossom_tornadodust and #p.mo.blossom_tornadodust then
					local dust, ang
					for i = 1, #p.mo.blossom_tornadodust do
						dust = p.mo.blossom_tornadodust[i]

						if dust and dust.valid then
							ang = R_PointToAngle2(p.mo.x, p.mo.y, dust.x, dust.y)
							P_InstaThrust(dust, ang, 20*FRACUNIT)
							dust.tics = 30
							dust.fuse = 30
						end
					end
				end

				local sound = p.tanukisuit and sfx_rocks1 or sfx_s3kcel
				if S_SoundPlaying(p.mo, sound) then S_StopSoundByID(p.mo, sound) end

				p.drawangle = p.mo.angle
				p.mo.blossom_cancelled = true
				p.mo.blossom_fastfall = nil
				p.mo.blossom_grounded = nil
				p.mo.blossom_tornado = nil
				p.pflags = (($ & ~PF_CANCARRY) & ~PF_SPINNING)|PF_JUMPED
				S_StartSound(p.mo, sfx_grass2)
				P_SetObjectMomZ(p.mo, 3*FRACUNIT)

				if hasShield(p, SH_ATTRACT) then
					releaseMobjs(p.mo)
				elseif hasShield(p, SH_FLAMEAURA) then
					P_Thrust(p.mo, p.drawangle, 25*FRACUNIT)
					S_StartSound(p.mo, sfx_grass2)
					p.pflags = $|PF_SHIELDABILITY
				end

				return
			end

			if p.mo.momz <= -FRACUNIT then p.mo.momz = -FRACUNIT end

			if p.mo.blossom_tornado <= 60 then
				tornadoAnim(p, p.mo)
				if not p.mo.blossom_grounded then
					if p.powers[pw_shield] then
						local didthing
						for k,v in pairs(shieldChanges) do
							if hasShield(p, k) then
								v(p)
								didthing = true
								break
							end
						end

						if not didthing and (p.mo.eflags & MFE_VERTICALFLIP and p.mo.momz >= -6*p.mo.scale) or (p.mo.momz <= 6*p.mo.scale) then
							P_SetObjectMomZ(p.mo, 4*FRACUNIT/3, true)
							p.pflags = $|PF_CANCARRY
						end
					elseif p.powers[pw_super] then
						if (p.mo.eflags & MFE_VERTICALFLIP and p.mo.momz >= -10*p.mo.scale) or (p.mo.momz <= 10*p.mo.scale) then
							P_SetObjectMomZ(p.mo, 3*FRACUNIT/2, true)
							p.pflags = $|PF_CANCARRY
						end
					else
						if (p.mo.eflags & MFE_VERTICALFLIP and p.mo.momz >= -6*p.mo.scale) or (p.mo.momz <= 6*p.mo.scale) then
							P_SetObjectMomZ(p.mo, 4*FRACUNIT/3, true)
							p.pflags = $|PF_CANCARRY
						end
					end
				end

				-- attraction shield
				local dist = 300*FRACUNIT
				if hasShield(p, SH_ATTRACT) then searchBlockmap("objects", attractShield, p.mo, p.mo.x-dist, p.mo.x+dist, p.mo.y-dist, p.mo.y+dist) end

				-- damage
				dist = 115*FRACUNIT
				if hasShield(p, SH_ARMAGEDDON) then
					dist = 280*FRACUNIT
				end

				searchBlockmap("objects", tornadoDamage, p.mo, p.mo.x-dist, p.mo.x+dist, p.mo.y-dist, p.mo.y+dist)

				-- Sounds
				local sound = p.tanukisuit and sfx_rocks1 or sfx_s3kcel
				if not S_SoundPlaying(p.mo, sound) then S_StartSound(p.mo, sound) end
			end

			if P_IsObjectOnGround(p.mo) and p.mo.blossom_grounded then tornadoBust(p) end
			if p.mo.blossom_grounded and not P_IsObjectOnGround(p.mo) then p.mo.blossom_grounded = nil end
			p.mo.blossom_tornado = $-1
			if p.mo.blossom_tornado <= 0 and p.mo.blossom_grounded and (p.cmd.buttons & BT_SPIN) and G_PlatformGametype() and ((CBW_Battle and CBW_Battle.Gametypes and not CBW_Battle.Gametypes.Battle[gametype]) or not CBW_Battle) then p.mo.blossom_tornado = 18 end

			if p.mo.blossom_tornado <= 0 then
				local sound = p.tanukisuit and sfx_rocks1 or sfx_s3kcel
				if S_SoundPlaying(p.mo, sound) then S_StopSoundByID(p.mo, sound) end

				p.pflags = $ & ~PF_SPINNING
				p.mo.state = p.mo.blossom_grounded and S_PLAY_STND or S_PLAY_FALL
				p.mo.blossom_grounded = nil
				p.mo.blossom_tornado = nil
				p.mo.blossom_tornado_cool = ((CBW_Battle and CBW_Battle.Gametypes and not CBW_Battle.Gametypes.Battle[gametype]) or not CBW_Battle) and 1 or 15
				p.pflags = $ & ~PF_CANCARRY
				if hasShield(p, SH_ATTRACT) then releaseMobjs(p.mo) end

				if p.mo.blossom_tornadodust and #p.mo.blossom_tornadodust then
					local dust, ang
					for i = 1, #p.mo.blossom_tornadodust do
						dust = p.mo.blossom_tornadodust[i]
						if dust and dust.valid then
							ang = R_PointToAngle2(p.mo.x, p.mo.y, dust.x, dust.y)
							P_InstaThrust(dust, ang, 20*FRACUNIT)
							dust.tics = 30
							dust.fuse = 30
						end
					end
				end
			end
		end
	elseif p.mo.blossom_didtornado and p.mo.buttons.spin == 1 and not p.mo.blossom_fastfall and not p.powers[pw_super] and not p.mo.blossom_didtwirl then
		p.drawangle = p.mo.angle
		p.mo.blossom_fastfall = nil
		p.pflags = $ & ~PF_SPINNING
		p.mo.blossom_grounded = nil
		p.mo.blossom_tornado = nil
		p.pflags = $ & ~PF_CANCARRY
		S_StartSound(p.mo, sfx_btwirl)
		P_SetObjectMomZ(p.mo, 1*FRACUNIT)

		p.mo.blossom_didtwirl = 30
		p.mo.state = S_PLAY_BLOSSOM_TORNADO
		p.mo.blossom_twirltimer = 10
		return 
	end
end)

rawset(_G, "Blossom_SpringHandler", function(mo, spring)
	if mo.skin ~= "blossom" then return end
	if not (spring.flags & MF_SPRING) return end

	if mo.z + mo.height >= spring.z and mo.z <= spring.z + spring.height then
		mo.blossom_grounded = nil
		mo.blossom_fastfall = nil
		mo.blossom_tornado = nil
		mo.blossom_didtornado = nil
		mo.blossom_wallslide = nil
		mo.flags = $ & ~MF_NOGRAVITY
		mo.player.pflags = $ & ~PF_CANCARRY
		mo.spritexscale = FRACUNIT
		mo.spriteyscale = FRACUNIT
	end
end)