if not srb2p then return end

-- Blossom's base stats.
charStats["blossom"] = {
	name = "Blossom",
	basehp = 57,
	basesp = 43,
	persona = "skadi_blossom",
	melee_natk = "blossom_atk1",

	supercolor_start = SKINCOLOR_SUPERPURPLE1,
	supername = "Super Blossom",

	atk = 40,
	acc = 999,
	crit = 7,

	wep = "blossom_01",
	weptype = WPT_HANDSONIC,

	anim_stand = 		{SPR_PLAY, A, 8, "SPR2_STND"},
	anim_stand_hurt =	{SPR_PLAY, A, 1, "SPR2_STND"},
	anim_stand_bored =	{SPR_PLAY, A, B, 17, "SPR2_MLEE"},
	anim_guard = 		{SPR_PLAY, A, 8, "SPR2_EDGE"},
	anim_move =			{SPR_PLAY, A, B, C, D, E, F, G, H, 2, "SPR2_WALK"},
	anim_run =			{SPR_PLAY, A, B, C, D, 2, "SPR2_RUN_"},
	anim_atk =			{SPR_PLAY, A, B, C, D, 3, "SPR2_TRND"},
	anim_aoa_end =		{SPR_PLAY, B, A, 10, "SPR2_FALL"},
	anim_hurt =			{SPR_PLAY, A, 35, "SPR2_PAIN"},
	anim_getdown =		{SPR_PLAY, A, 1, "SPR2_CNT1"},
	anim_downloop =		{SPR_PLAY, A, 1, "SPR2_CNT1"},
	anim_getup =		{SPR_PLAY, A, B, C, D, 2, "SPR2_TRND"},
	anim_death =		{SPR_PLAY, A, 30, "SPR2_DEAD"},
	anim_revive =		{SPR_PLAY, A, B, 10, "SPR2_FALL"},
	anim_evoker =		{SPR_PLAY, A, 8, "SPR2_STND"},

	anim_special2 =		{SPR_PLAY, A, 1, "SPR2_HUG_"},
	anim_special3 =		{SPR_PLAY, A, 1, "SPR2_SPNG"},
	anim_special4 =		{SPR_PLAY, A, 1, "SPR2_GASP"},						
	anim_special5 =		{SPR_PLAY, A, B, C, D, 2, "SPR2_TRND"},
	anim_special6 = 	{SPR_PLAY, A, 1, "SPR2_FALL"},
	
	
	vfx_summon = {"sfx_spsum1", "sfx_spsum2", "sfx_spsum3", "sfx_spsum4", "sfx_spsum5", "sfx_spsum6", "sfx_spsum7", "sfx_spsum8"},	-- Summoning Persona to use a Skill
	vfx_skill = {"sfx_spskl1", "sfx_spskl2", "sfx_spskl3", "sfx_spskl4", "sfx_spskl5", "sfx_spskl6", "sfx_spskl7"},					-- Used a Skill
	vfx_item = {"sfx_spuse1", "sfx_spuse2", "sfx_spuse3", "sfx_spuse4", "sfx_spuse5"},		-- Used an item
	vfx_hurt = {"sfx_sphrt1", "sfx_sphrt2", "sfx_sphrt3", "sfx_sphrt4", "sfx_sphrt5", "sfx_sphrt6", "sfx_sphrt7"},					-- Sustained damage
	vfx_hurtx = {"sfx_sphrx1", "sfx_sphrx2", "sfx_sphrx3", "sfx_sphrx4", "sfx_sphrx5", "sfx_sphrx6", "sfx_sphrx7", "sfx_sphrx8", "sfx_sphrx9"},		-- Sustained heavy damage / Critical hit / Weakness
	vfx_die = {"sfx_spdie1", "sfx_spdie2", "sfx_spdie3", "sfx_spdie4", "sfx_spdie5", "sfx_spdie6", "sfx_spdie7"},					-- Death
	vfx_heal = {"sfx_sphel1", "sfx_sphel2", "sfx_sphel3", "sfx_sphel4", "sfx_sphel5"},		-- Healed by teammate
	vfx_healself = {"sfx_sphes1", "sfx_sphes2", "sfx_sphes3", "sfx_sphes4", "sfx_sphes5"},	-- Healed self
	vfx_killconfirm = {"sfx_spskl1", "sfx_spskl2", "sfx_spskl3", "sfx_spskl4", "sfx_spskl5", "sfx_spskl6", "sfx_spskl7"},			-- When the enemy will die from your attack
	vfx_kill = {"sfx_spkll1", "sfx_spkll2"},												-- Killed an enemy
	vfx_1more = {"sfx_sp1mr1", "sfx_sp1mr2"},												-- Performed 1more
	vfx_crit = {"sfx_spcrt1", "sfx_spcrt2"},												-- Cut-in for Weakness/Critical Hit
	vfx_aoaask = {"sfx_spaoi1", "sfx_spaoi2", "sfx_spaoi3"},								-- Ask to All-Out Attack
	vfx_aoado = {"sfx_spaoa1"},																-- Performing All-Out Attack
	vfx_aoarelent = {"sfx_spaor1", "sfx_spaor2"},											-- Relenting from All-Out Attack
	vfx_miss = {"sfx_spmis1", "sfx_spmis2", "sfx_spmis3", "sfx_spmis4", "sfx_spmis5", "sfx_spmis6", "sfx_spmis7"},					-- Missed attack
	vfx_dodge = {"sfx_spdge1", "sfx_spdge2"},												-- Dodged enemy attack
	vfx_win = {"sfx_spwin1", "sfx_spwin2", "sfx_spwin3", "sfx_spwin4", "sfx_spwin5"},		-- Battle won
	vfx_levelup = {"sfx_splvl1", "sfx_splvl2"},												-- Level Up!
	
	vfx_tartarus_item = {"sfx_sphes5", "sfx_spwin3", "sfx_splvl2"},
	vfx_tartarus_spring = {"sfx_sphes1", "sfx_sp1mr1"},
	vfx_tartarus_encounter = {"sfx_spaoa1", "sfx_spaoi2"},
	vfx_tartarus_advantage = {"sfx_spkll1", "sfx_sp1mr2"},
	vfx_tartarus_ambushed = {"sfx_sphrt6", "sfx_sphrt7", "sfx_sphrx9"},

	icon = "ICO_BLS",
	hudbust = "BLS_H",
	hudaoa = "H_BLSAOA",
	hudcutin = "BLOS_A",
	aoa_quote = "Ok everyone... \nlet's do it!",

	tip = "Learns Slash, Ice, Curse, and Support skills. Blossom is an all-round mage who can deal heavy damage at will, and assist allies in dealing extra damage with her Wisp! Despite being frail, she can be a useful asset to her party.",
}

-- The Persona(tm)
personaList["skadi_blossom"] = {
	name = "Skadi",
	arcana = ARCANA_PRIESTRESS,
	trait = "trepidation",

	sprite = SPR_SKAD,
	anim_idle = 	{SPR_SKAD, A, B, C, D, 7},
	anim_atk = 		{SPR_SKAD, E, E, E, E, F, F, F, G, G, G, G, G, G, G, G, G, G, 3},

	strength = 7,
	magic = 12,
	endurance = 6,
	luck = 8,
	agility = 7,

	weak = ATK_FIRE,
	resist = ATK_CURSE|ATK_ICE,

	skills = {
		{"bufu", 1},
		{"wisp", 5}, 
		{"cleave", 9},
		{"maeiha", 12},

		{"toxic slice", 18, "cleave"},
		{"bufula", 24, "bufu"},
		{"will o wisp", 29, "wisp"},
		{"curse boost", 33},

		{"merciless slayer", 37},
		{"maeiga", 44, "maeiha"},

		{"mind charge", 50},
		{"tetraja", 54},
		{"virus cutter", 57, "toxic slice"},

		{"ignis fatuus", 61, "will o wisp"},
		{"bufudyne", 65, "bufula"},
		{"curse amp", 70, "curse boost"},

		{"maeigaon", 76, "maeiga"},
		{"rise the dead", 84, "ignis fatuus"}
	},
}

-- Bionis stuff.
local didbionis = false
addHook("ThinkFrame", function()
	if didbionis then return end

	if bionis then
		personaList["skadi_blossom"].weak = $|ATK_POISON
		personaList["skadi_blossom"].resist = $|ATK_METAL
		didbionis = true
	end
end)